<# :# DO NOT REMOVE THIS LINE

:: █▀█ █▄▄ ▄▀█ █▀▀ ▀█▀ █ █░█ ▄▀█ ▀█▀ █▀█ █▀█
:: ▀▀█ █▄█ █▀█ █▄▄ ░█░ █ ▀▄▀ █▀█ ░█░ █▄█ █▀▄

:: qbactivator.cmd, Version 0.24.0
:: Copyright (c) 2023, neuralpain
:: https://github.com/neuralpain/qbactivator
:: QuickBooks POS activation script

@echo off
@mode 60,22
@title QuickBooks POS Activator v0.24.0
set "wdir=%~dp0"
set "pwsh=PowerShell -NoP -C"
setlocal EnableExtensions DisableDelayedExpansion
set ARGS=%*
if defined ARGS set ARGS=%ARGS:"=\"%
if defined ARGS set ARGS=%ARGS:'=''%

:: check admin permissions
fsutil dirty query %systemdrive% >nul
:: if error, we do not have admin.
if %ERRORLEVEL% NEQ 0 (
  cls & echo.
  echo This script requires administrative privileges.
  echo Attempting to elevate...
  goto UAC_Prompt
) else ( goto :init )

:UAC_Prompt
set n=%0 %*
set n=%n:"=" ^& Chr(34) ^& "%
echo Set objShell = CreateObject("Shell.Application")>"%tmp%\cmdUAC.vbs"
echo objShell.ShellExecute "cmd.exe", "/c start " ^& Chr(34) ^& "." ^& Chr(34) ^& " /d " ^& Chr(34) ^& "%CD%" ^& Chr(34) ^& " cmd /c %n%", "", "runas", ^1>>"%tmp%\cmdUAC.vbs"
cscript "%tmp%\cmdUAC.vbs" //Nologo
del "%tmp%\cmdUAC.vbs"
goto :eof

:init
cls & echo.
echo Initializing. Please wait...
%pwsh% ^"Invoke-Expression ('^& {' + (Get-Content -Raw '%~f0') + '} %ARGS%')"

if %ERRORLEVEL% EQU 0 (
  echo Starting services...
  net start "Intuit Entitlement Service v8" >nul 2>&1
  goto :pos_activation
) else if %ERRORLEVEL% EQU 3 (
  @REM pause screen before exiting
  echo. & pause
  goto exitQBA
) else if %ERRORLEVEL% EQU 5 (
  echo Starting services...
  net start "Intuit Entitlement Service v8" >nul 2>&1
  goto :standard_activation
) else goto exitQBA

:pos_activation
net start "QBPOSDBServiceV11" >nul 2>&1
set "QBPOSDIR11=C:\Program Files (x86)\Intuit\QuickBooks Point of Sale 11.0\QBPOSShell.exe"
set "QBPOSDIR12=C:\Program Files (x86)\Intuit\QuickBooks Point of Sale 12.0\QBPOSShell.exe"
set "QBPOSDIR18=C:\Program Files (x86)\Intuit\QuickBooks Desktop Point of Sale 18.0\QBPOSShell.exe"
set "QBPOSDIR19=C:\Program Files (x86)\Intuit\QuickBooks Desktop Point of Sale 19.0\QBPOSShell.exe"
set "CLIENT_MODULE=%SystemRoot%\Microsoft.NET\assembly\GAC_MSIL\Intuit.Spc.Map.EntitlementClient.Common\v4.0_8.0.0.0__5dc4fe72edbcacf5\Intuit.Spc.Map.EntitlementClient.Common.dll"

:: start quickbooks
echo Starting QuickBooks...
if exist "%QBPOSDIR19%" (
  %pwsh% "Start-Process -FilePath '%QBPOSDIR19%'"
) else if exist "%QBPOSDIR18%" (
  %pwsh% "Start-Process -FilePath '%QBPOSDIR18%'"
) else if exist "%QBPOSDIR12%" (
  %pwsh% "Start-Process -FilePath '%QBPOSDIR12%'"
) else if exist "%QBPOSDIR11%" (
  %pwsh% "Start-Process -FilePath '%QBPOSDIR11%'"
)

:: export and open minified readme
pushd "%wdir%"
set "0=%~f0"
%pwsh% "$f=[IO.File]::ReadAllText($env:0) -split ':qbreadme\:.*'; [IO.File]::WriteAllText('README.txt',$f[1].Trim(),[System.Text.Encoding]::UTF8)"
popd & start notepad.exe "README.txt"

@mode 60,18
cls & echo.
%pwsh% "Write-Host ' qbactivator ' -ForegroundColor White -BackgroundColor DarkGreen"
echo.
echo Follow the steps below to activate QuickBooks software.
echo.
echo 1. QuickBooks should open automatically
echo -- DO NOT check for updates
echo 2. Select "Open Practice Mode"
echo 3. Select "Use Sample Data..."
echo 4. Click "Register by phone now"
echo 5. Enter the code 999999
echo 6. Click Next
echo 7. Click Finish
echo.
echo -- Continue when finished.
echo. & pause
goto end_activation

:standard_activation
@mode 60,17
cls & echo.
%pwsh% "Write-Host ' qbactivator ' -ForegroundColor White -BackgroundColor DarkGreen"
echo.
echo Follow the steps below to activate QuickBooks software.
echo.
echo 1. Open the QuickBooks software
echo 2. Click "Help" then "About..." 
echo 3. Press CTRL+R+P
echo 4. Enter the code 99999930
echo 5. Click Next
echo 6. Click Finish
echo 7. Close QuickBooks
echo.
echo -- Continue when finished.
echo. & pause
goto end_activation

:end_activation
:: end activation and end all QuickBooks processes
cls & echo.
echo Terminating QuickBooks processes...
taskkill /fi "imagename eq qb*" /f /t >nul 2>&1
taskkill /fi "imagename eq intuit*" /f /t >nul 2>&1
taskkill /f /im qbw.exe >nul 2>&1
taskkill /f /im qbw32.exe >nul 2>&1
taskkill /f /im qbupdate.exe >nul 2>&1
taskkill /f /im qbhelp.exe >nul 2>&1
taskkill /f /im QBCFMonitorService.exe >nul 2>&1
taskkill /f /im QBUpdateService.exe >nul 2>&1
taskkill /f /im IBuEngHost.exe >nul 2>&1
taskkill /f /im msiexec.exe >nul 2>&1
taskkill /f /im mscorsvw.exe >nul 2>&1
taskkill /f /im QBWebConnector.exe >nul 2>&1
taskkill /f /im QBDBMgr9.exe >nul 2>&1
taskkill /f /im QBDBMgr.exe >nul 2>&1
taskkill /f /im QBDBMgrN.exe >nul 2>&1
taskkill /f /im QuickBooksMessaging.exe >nul 2>&1
:: restore files to original state
echo Attempting to restore client module...
copy /v /y /z "%CLIENT_MODULE%.bak" "%CLIENT_MODULE%" >nul
fc "%CLIENT_MODULE%" "%CLIENT_MODULE%.bak" > nul
:: error handling if files have not been restored
if %ERRORLEVEL% EQU 1 (
  cls & echo.
  echo qbactivator ran into a problem while attempting to restore
  echo the client.
  echo.
  echo Restart qbactivator and go through the troubleshooting
  echo "Lv1: Restore" to resolve the error. You may choose to
  echo exit the script afterwards.
  echo. & pause
  goto :exitQBA
) else (
  del /q /f /a "%CLIENT_MODULE%.bak"
  echo Restoration successful.
  ping -n 1 127.0.0.1 >nul
  echo Patch completed without errors.
  ping -n 1 127.0.0.1 >nul
  goto :exitQBA
)

:exitQBA
:: clean up files and exit script
taskkill /f /fi "WindowTitle eq README*" >nul 2>&1
del "%wdir%README.txt" >nul 2>&1
cls & echo.
echo qbactivator will now terminate.
ping -n 1 127.0.0.1 >nul
goto :eof

:qbreadme:

          █▀█ █▄▄ ▄▀█ █▀▀ ▀█▀ █ █░█ ▄▀█ ▀█▀ █▀█ █▀█
          ▀▀█ █▄█ █▀█ █▄▄ ░█░ █ ▀▄▀ █▀█ ░█░ █▄█ █▀▄

                   Simplified README v2.7

Activation script for QuickBooks Point Of Sale Software on Windows.

For more information on this activation script, visit
<https://github.com/neuralpain/qbactivator/wiki>

Take a moment to read the FAQs for any issues you may encounter:
<https://github.com/neuralpain/qbactivator/wiki/FAQs>

!!! An internet connection is required.

[ --- Instructions for activation --- ]

 1. Run "qbactivator.cmd", select the store you need to install and
    activate (Store 1 or Store 2) and allow the QuickBooks software to 
    install completely before you continue the activation.
 
<?> If you are installing on Client, exit the activator after the
    software is installed. The Client will be activated automatically
    with the license from the Server workstation.
 
 2. Uncheck the "Launch QuickBooks" box.
 3. Click Finish and continue with the script. QuickBooks will open 
    automatically.
 4. You will be asked for Administrative privileges. Click Next.
 5. Select "Open Practice Mode"
 6. Click Next
 7. Select "Use Sample Data..."
 8. Click Next
 9. Click OK
10. Click "Register by phone now"
11. Enter the code `999999`
12. Click Next
13. Click Finish

<?> The software might seem frozen but it just takes a few seconds
    for the UI to load. It will greet you with a dialog informing you 
    that "You are in Practice Mode" when it is ready for interaction 
    along with a yellow indicator in the top-right.
 
<?> You can end the activation here or continue to add more users if
    that is something you need.

[ --- OPTIONAL --- Steps 18-23 are for adding more users --- ]
[ ---------------- on the Server workstation --------------- ]

14. Click the "Help" option in the menu bar
15. Click "Manage My License"
16. Click "Buy Additional User License"
17. Enter the code for the number of users you want

<?> For 5 users use "9999995". For 30 users use "99999930", etc.

18. Click Next
19. Click Finish
20. Exit the software
21. Continue the script

@neuralpain // 'cause why not?
With help from @Navish360
--
Original patch by Beast_iND
:qbreadme:

# ---------- PowerShell Script ---------- #>

<#
  qbactivator, PowerShell Core
  Copyright (c) 2023, neuralpain
  Module for activation of QuickBooks Point of Sale
#>

$OK = 0x0000
$ERR = 0x0001
$EXIT_QBA = 0x0002 # no action; complete exit
$PAUSE = 0x0003

$TIME_BLINK = 500
$TIME_SHORT = 800
$TIME_NORMAL = 1000
$TIME_SLOW = 2000

# THIS! ...because Enums in PowerShell don't work how I want them to
$PROC_INSTALL = 0x208a
$PROC_ACTIVATE = 0x208b
$PROC_WRITE_LIES = 0x208c
$PROC_LICENSE = 0x208d
$PROC_TROUBLESHOOT = 0x208e
$PROC_EXIT = 0x208f
$PROC_EMPTY = 0x2090
$PROC_COMPLETE_EXIT = 0x2091
$PROC_NEXT_STAGE = 0x2092
$PROC_DOWNLOAD = 0x2093
$PROC_RETURN_MAIN = 0x2094

# MISCELLANEOUS
$Script:LICENSE_KEY = ""                          # quickbooks license key
$Script:QB_VERSION = $null                        # version of quickbooks (to be) installed
$Script:SELECTED_QB_OBJECT = $null                # quickbooks object selected to be installed
$Script:TARGET_LOCATION = "$pwd"                  # directory where files will be downloaded
$Script:RUN_NEXT_PROCEDURE = $null                # WAS UNUSED, FOUND A USE FOR IT; contains the next step to be run
$Script:ACTIVATION_ONLY = $false                  # indicate whether or not the script should only activate quickbooks

# IF QUICKBOOKS IS INSTALLED
[bool]$Script:QUICKBOOKS_IS_INSTALLED = $false    # indicate whether or not quickbooks is installed
$Script:QUICKBOOKS_INSTALLED_PATH = $null         # path where quickbooks is installed
$Script:QUICKBOOKS_INSTALLED_VERSION = $null      # version of quickbooks installed
$Script:QUICKBOOKS_INSTALL_ONLY = $false          # indicate whether or not the script should only install quickbooks

# INSTALLER RELATED
$Script:INSTALLER_SIZE = 0                        # size of installer
[int]$Script:INSTALLER_BITS = 0                   # bit size of installer
[int]$Script:INSTALLER_BYTES = 0                  # byte size of installer
$Script:INSTALLER_OBJECT = $null                  # the installer, the `.exe` object
$Script:INSTALLER_PATH = $null                    # path to the installer
$Script:INSTALLER_HASH = $null                    # hash of the installer
$Script:INSTALLER_IS_VALID = $false               # indicate whether or not the installer is valid for use
[bool]$Script:INSTALLER_AVAILABLE = $false        # indicate whether or not the installer is available on the user's system
[bool]$Script:INSTALLER_DOWNLOAD_ONLY = $false    # indicate whether or not the script should only download the installer

# BANDWIDTH RELATED
[int]$Script:BANDWIDTH_BITS = 0                   # bit size of bandwidth
[int]$Script:RAW_DOWNLOAD_TIME = 0                # raw download time
[int]$Script:BANDWIDTH_BYTES = 0                  # byte size of bandwidth
# [bool]$Script:DOWNLOAD_PATCH = $false           # UNUSED
[bool]$Script:BANDWIDTH_UNKNOWN = $true           # indicate whether or not bandwidth is unknown; bandwidth text successful or failed
[double]$Script:BANDWIDTH = 0                     # bandwidth size

# STORE RELATED
[bool]$Script:SECOND_STORE = $false               # indicate whether or not there is a second store
[bool]$Script:CUSTOM_LICENSING = $false           # indicate whether or not the user added a custom license
[bool]$Script:ADDITIONAL_CLIENTS = $false         # indicate whether or not the user wants to activate additional clients

# CONFIG
# $Script:ALLOW_ONLINE = 1                        # UNUSED
# $Script:TOAST_NOTIFICATIONS = 1                 # enable toast notifications, UNUSED

# download and security level preferences
$Script:ProgressPreference = "SilentlyContinue"
# securely enable TLS 1.2 to download files
[System.Net.ServicePointManager]::SecurityProtocol = [System.Net.ServicePointManager]::SecurityProtocol -bor [System.Net.SecurityProtocolType]::Tls12

# log file
$LOG = "C:\Windows\Logs\qbactivator\qbactivator_$(Get-Date -Format "yyyyMMdd_HHmmss").log"

# temp folder for Intuit (is this folder still being used?)
$intuit_temp = "$env:TEMP\Intuit"

class Installer {
  [string] $WindowTitle      # installer window data
  [System.Object] $Object    # POS Installer Object
  [string] $Url              # download url
  [string] $Name             # name of installer
  [string] $VerNum           # POS version number, e.g. 11 
  [string] $Year             # POS release year, e.g. 2013
  [string] $Hash             # installer hash value
  [string] $Path             # insatllation path
  [string] $LNum1            # license number #1
  [string] $LNum2            # license number #2
  [string] $PNum             # product number
  [string] $Validation       # validation string
  [int]    $XBits            # installer bit size
  [int]    $XByte            # installer byte size
  [string] $Size             # installer megabyte size
}

$POS11InstObj = [Installer]@{
  WindowTitle = 'QuickBooks Point of Sale 2013'
  Url         = 'https://dlm2.download.intuit.com/akdlm/SBD/QuickBooks/2013/Latest/QuickBooksPOSV11.exe'
  Name        = 'QuickBooksPOSV11.exe'
  VerNum      = '11'
  Year        = '2013'
  Hash        = 'A1AF552A49ADFF40E6462A968DD552A4'
  Path        = 'Intuit\QuickBooks Point of Sale 11.0'
  LNum1       = '1063-0575-1585-222'
  LNum2       = '8432-0480-0178-029'
  PNum        = '023-147'
  XBits       = 164665944
  XByte       = 20583243
  Size        = '157.03'
}

$POS12InstObj = [Installer]@{
  WindowTitle = 'QuickBooks Desktop Point of Sale 12.0'
  Url         = 'https://dlm2.download.intuit.com/akdlm/SBD/QuickBooks/2015/Latest/QuickBooksPOSV12.exe'
  Name        = 'QuickBooksPOSV12.exe'
  VerNum      = '12'
  Year        = '2015'
  Hash        = '30FB99C5E98DF6874D438C478314EF9D'
  Path        = 'Intuit\QuickBooks Point of Sale 12.0'
  LNum1       = '6740-7656-8840-594'
  LNum2       = '0877-0442-6111-615'
  PNum        = '448-229'
  XBits       = 461077328
  XByte       = 57634666
  Size        = '439.71'
}

$POS18InstObj = [Installer]@{
  WindowTitle = 'QuickBooks Desktop Point of Sale 18.0'
  Url         = 'https://dlm2.download.intuit.com/akdlm/SBD/QuickBooks/2018/Latest/QuickBooksPOSV18.exe'
  Name        = 'QuickBooksPOSV18.exe'
  VerNum      = '18'
  Year        = '2018'
  Hash        = 'DD45AA4EC0DF431243C9836816E2305A'
  Path        = 'Intuit\QuickBooks Desktop Point of Sale 18.0'
  LNum1       = '2421-4122-2213-596'
  LNum2       = '3130-3560-7860-900'
  PNum        = '818-769'
  XBits       = 637981160
  XByte       = 79747645
  Size        = '608.42'
}

$POS19InstObj = [Installer]@{
  WindowTitle = 'QuickBooks Desktop Point of Sale 19.0'
  Url         = 'https://dlm2.download.intuit.com/akdlm/SBD/QuickBooks/2019/Latest/QuickBooksPOSV19.exe'
  Name        = 'QuickBooksPOSV19.exe'
  VerNum      = '19'
  Year        = '2019'
  Hash        = 'F5C434677270319F9A515210CA916187'
  Path        = 'Intuit\QuickBooks Desktop Point of Sale 19.0'
  LNum1       = '0106-3903-4389-908'
  LNum2       = '7447-0864-8898-657'
  PNum        = '595-828'
  XBits       = 1017415680
  XByte       = 127176960
  Size        = '970.28'
}

<#
$PosInstalerExe = [Installer]@{
  Object = $null
  Name   = $null
  VerNum = $null
  Year   = $null
  Hash   = $null
  Path   = $null
  LNum1  = $null
  LNum2  = $null
  PNum   = $null
  XBits  = 0
  XByte  = 0
  Size   = 0
}
#>

# start list from most recent version first
$qbVersionList = 11, 12, 18, 19
$qbExeList = $POS11InstObj.Name, $POS12InstObj.Name, $POS18InstObj.Name, $POS19InstObj.Name
$qbHashList = $POS11InstObj.Hash, $POS12InstObj.Hash, $POS18InstObj.Hash, $POS19InstObj.Hash
$qbPathList = $POS11InstObj.Path, $POS12InstObj.Path, $POS18InstObj.Path, $POS19InstObj.Path

# extra licenses
$pos19_licenses = @("4569-3302-3865-178", "7881-1645-9971-269", "4938-5814-0940-038", "4808-1135-2336-049", "2851-9930-2558-997", "6120-5395-3507-303", "9987-3884-2589-215", "2708-9947-4862-202", "5009-9403-1002-207", "8409-4961-4037-794", "3053-7747-9128-534", "7786-9879-2771-754", "7487-0743-3346-368", "9280-8996-7677-618", "5956-5105-0683-052", "7767-9250-5701-417")
$pos18_licenses = @("4798-4713-5577-215", "6108-6944-0442-313", "9877-7080-8166-654", "9324-1610-3399-773", "0332-2949-2962-553", "9795-2504-8646-275", "6793-3031-4084-521", "9122-6269-9978-972", "7318-8184-8823-424", "3616-4890-7410-775", "5417-1662-5253-895", "4942-3840-9153-387", "3477-1552-0630-590", "3815-2087-1596-845", "4279-4883-7575-102", "2046-1663-3706-369")
$pos12_licenses = @("0023-8629-2358-007", "2289-2505-2376-712", "2069-3001-1276-177", "1596-0116-8423-156", "9884-4020-2536-935", "0454-9731-8461-756", "6632-9109-5515-608", "5460-5353-7861-933", "3390-0307-6528-013", "5581-2740-9316-682", "1627-7594-2197-477", "6603-6131-8677-496", "4416-4005-9128-286", "8664-0924-4097-580", "4041-6901-8695-956", "6643-0061-1816-223")
$pos11_licenses = @("4152-7820-7508-121", "4710-8115-1842-661", "6666-1981-1862-788", "3006-9510-2311-039", "7943-2223-9879-816", "0097-1334-7945-038", "6111-6942-7154-813", "6711-1593-7271-896", "1886-6113-4556-755", "6212-2023-0526-681", "8040-0005-4774-245", "6925-4558-7435-923", "0417-2770-7838-353", "1690-6238-0164-884", "4557-9535-0444-555", "7718-8079-1215-532")

# client patch and repair
$PATCH_HASH = "1A1816C78925E734FCA16974BDBAA4AA"
$LOCAL_PATCH_FILE = ".\EntClient.dll"
$LOCAL_GENUINE_FILE = ".\EntClientGenuine.dll"
$CLIENT_FILE_ON_HOST = "https://raw.githubusercontent.com/neuralpain/qbactivator/main/src/bin/ecc/EntClient.dll"
$GENUINE_CLIENT_FILE_ON_HOST = "https://raw.githubusercontent.com/neuralpain/qbactivator/main/src/bin/ecc/EntClientGenuine.dll"

$CLIENT_MODULE_DATA = "EntitlementDataStore.ecml"
$CLIENT_MODULE_DATA_PATH = "$env:ProgramData\Intuit\Entitlement Client\v8"
$CLIENT_MODULE_DATA_FULL_PATH = "$CLIENT_MODULE_DATA_PATH\$CLIENT_MODULE_DATA"

$CLIENT_MODULE = "Intuit.Spc.Map.EntitlementClient.Common.dll"
$CLIENT_MODULE_PATH = "$env:SystemRoot\Microsoft.NET\assembly\GAC_MSIL\Intuit.Spc.Map.EntitlementClient.Common\v4.0_8.0.0.0__5dc4fe72edbcacf5"
$CLIENT_MODULE_FULL_PATH = "$CLIENT_MODULE_PATH\$CLIENT_MODULE"

$InitializeMain = {
  $Script:QB_VERSION = $null
  $Script:ACTIVATION_ONLY = $false
  $Script:INSTALLER_SIZE = 0
  $Script:INSTALLER_BITS = 0
  $Script:INSTALLER_BYTES = 0
  $Script:INSTALLER_OBJECT = $null
  $Script:INSTALLER_PATH = $null
  $Script:INSTALLER_HASH = $null
  $Script:INSTALLER_IS_VALID = $false
  $Script:INSTALLER_AVAILABLE = $false
  # $Script:BANDWIDTH = 0
  # $Script:BANDWIDTH_BITS = 0
  # $Script:BANDWIDTH_BYTES = 0
  # $Script:BANDWIDTH_UNKNOWN = $false
  $Script:RAW_DOWNLOAD_TIME = 0
  $Script:SECOND_STORE = $false
  $Script:CUSTOM_LICENSING = $false
  $Script:QUICKBOOKS_IS_INSTALLED = $false
  $Script:ADDITIONAL_CLIENTS = $false
}

$OpenLogs = {
  New-ToastNotification -ToastText "Locating qbactivator logs..." -ToastTitle "qbactivator"
  explorer.exe "C:\Windows\Logs\qbactivator"
}

$InvokeGeneralActivation = {
  Clear-Terminal
  Stop-QuickBooksProcesses
  New-ToastNotification -ToastText "Forced General Activation initiated" -ToastTitle "qbactivator"
  Invoke-NextProcess $PROC_NEXT_STAGE
}  

$ExitQbactivator = {
  New-ToastNotification -ToastText "Exiting qbactivator..." -ToastTitle "qbactivator"
  Invoke-NextProcess $PROC_EXIT
}  

$OpenWiki = { 
  New-ToastNotification -ToastText "Opening qbactivator Wiki..." -ToastTitle "qbactivator"
  Invoke-URLInDefaultBrowser -URL "https://github.com/neuralpain/qbactivator/wiki" 
}  

$TestInternetAvailable = {
  Write-Host -NoNewline "Testing connectivity... "
  if (-not(Test-Connection www.google.com -Quiet)) { 
    Write-Error_NoInternetConnectivity
    Invoke-NextProcess $PROC_RETURN_MAIN
  }
  else { Write-Host "OK" }
}

$VerifyIfQuickBooksIsInstalled = {
  foreach ($path in $qbPathList) {
    if (Test-Path "${env:ProgramFiles(x86)}\$path\QBPOSShell.exe" -PathType Leaf) { 
      Write-Host "Found `"$path`""
      $Script:QUICKBOOKS_IS_INSTALLED = $true
      $Script:QUICKBOOKS_INSTALLED_PATH = $path
      $Script:INSTALLER_DOWNLOAD_ONLY = $true
      break
    }
  }
}

$CheckQuickBooksIsNotInstalled_ReturnToMainMenu = {
  if (-not($Script:QUICKBOOKS_IS_INSTALLED)) { 
    Write-Host "Disabled when QuickBooks is not installed." -ForegroundColor Yellow
    $Script:SECOND_STORE = $false
    $Script:ADDITIONAL_CLIENTS = $false
    Start-Sleep -Milliseconds $TIME_NORMAL
    Invoke-NextProcess $PROC_RETURN_MAIN
  }
}

$CheckQuickBooksIsInstalled_ReturnToMainMenu = {
  if ($Script:QUICKBOOKS_IS_INSTALLED) { 
    Write-Host "Disabled when QuickBooks is installed." -ForegroundColor Yellow
    $Script:SECOND_STORE = $false
    $Script:ADDITIONAL_CLIENTS = $false
    Start-Sleep -Milliseconds $TIME_NORMAL
    Invoke-NextProcess $PROC_RETURN_MAIN
  }
}

$ValidateQuickBooksInstaller = {
  Write-Host -NoNewLine "Verifying `"$($Script:INSTALLER_OBJECT)`"... "
  foreach ($hash in $qbHashList) {
    if (Compare-IsValidHash -Hash $hash -File $Script:INSTALLER_OBJECT) {
      Write-Host "$($Script:INSTALLER_OBJECT) is valid."
      $Script:INSTALLER_IS_VALID = $true
      $Script:INSTALLER_HASH = $hash
      return
    }
  }
  # mark installer as invalid
  Write-Host "Invalid."
  $Script:INSTALLER_IS_VALID = $false
  Write-Error_UnableToVerifyInstaller
}

$LocateQuickBooksInstaller = {
  Write-Host "`nLocating QuickBooks POS installer..."
  # Find which installer version is available and compare 
  # known hashes against the installer for verification
  foreach ($exe in $qbExeList) {
    if (Test-Path ".\$exe" -PathType Leaf) {
      Write-Host "Found `"$exe`""
      $Script:INSTALLER_AVAILABLE = $true
      $Script:INSTALLER_OBJECT = $exe
      Set-Version ($exe.Trim("QuickBooksPOSV.exe"))
    }
  }
}

function Clear-Terminal { Clear-Host; Write-Host }
function Set-Version($v) { $Script:QB_VERSION = $v }
function Get-Version { return $Script:QB_VERSION }
function Set-License($l) { $Script:LICENSE_KEY = $l }
function Get-License { return $Script:LICENSE_KEY }

function Clear-IntuitData {
  # Delete Intuit POS installation debris
  Write-Host "Removing previous installation files... "
  
  foreach ($path in $qbPathList) {
    # remove quickbooks pos program data folder
    if (Test-Path "$env:ProgramData\$path") {
      Remove-Item "$env:ProgramData\$path" -Recurse -Force >$null 2>&1 
      Write-Host "Removed $(Format-Text "$env:ProgramData\$path" -Foreground Yellow -Formatting Underline)"
    }
    # remove folder of the last quickbooks pos version installed
    if (Test-Path "${env:ProgramFiles(x86)}\$path") {
      Remove-Item "${env:ProgramFiles(x86)}\$path" -Recurse -Force >$null 2>&1
      Write-Host "Removed $(Format-Text "${env:ProgramFiles(x86)}\$path" -Foreground Yellow -Formatting Underline)"
    }
    # remove previous copy of sample practice company
    if (Test-Path "$env:PUBLIC\Documents\$path\Data\Sample Practice") {
      Remove-Item "$env:PUBLIC\Documents\$path\Data\Sample Practice" -Recurse -Force >$null 2>&1
      Write-Host "Removed sample practice data at`n$(Format-Text "$env:PUBLIC\Documents\$path" -Foreground Yellow -Formatting Underline)"
    }
  }
  
  # Remove entitlement data store
  if (Test-Path "$env:PUBLIC\Documents\$path\Data\Sample Practice") {
    Remove-Item -Path $CLIENT_MODULE_DATA_PATH -Recurse -Force >$null 2>&1
    Write-Host "Removed activation data at`n$(Format-Text "$CLIENT_MODULE_DATA_PATH" -Foreground Yellow -Formatting Underline)"
  }
}

function Stop-QuickBooksProcesses {
  Write-Host "Terminating QuickBooks processes... "
  try { 
    taskkill.exe /fi "imagename eq qb*" /f /t >$null 2>&1
    taskkill.exe /fi "imagename eq intuit*" /f /t >$null 2>&1
    taskkill.exe /f /im qbw.exe >$null 2>&1
    taskkill.exe /f /im qbw32.exe >$null 2>&1
    taskkill.exe /f /im qbupdate.exe >$null 2>&1
    taskkill.exe /f /im qbhelp.exe >$null 2>&1
    taskkill.exe /f /im QBCFMonitorService.exe >$null 2>&1
    taskkill.exe /f /im QBUpdateService.exe >$null 2>&1
    taskkill.exe /f /im IBuEngHost.exe >$null 2>&1
    taskkill.exe /f /im msiexec.exe >$null 2>&1
    taskkill.exe /f /im mscorsvw.exe >$null 2>&1
    taskkill.exe /f /im QBWebConnector.exe >$null 2>&1
    taskkill.exe /f /im QBDBMgr9.exe >$null 2>&1
    taskkill.exe /f /im QBDBMgr.exe >$null 2>&1
    taskkill.exe /f /im QBDBMgrN.exe >$null 2>&1
    taskkill.exe /f /im QuickBooksMessaging.exe >$null 2>&1
    Write-Host "QuickBooks processes terminated."
    New-ToastNotification -ToastText "QuickBooks processes terminated" -ToastTitle "qbactivator"
  }
  catch {
    Write-Host "Error terminating QuickBooks processes. Error: $_"
    New-ToastNotification -ToastText "Error terminating QuickBooks processes" -ToastTitle "qbactivator"
  }
}

function Compare-IsValidHash {
  <#
  .SYNOPSIS
    Compares the file hash (MD5) of the specified file against the provided hash.

  .DESCRIPTION
    This function uses PowerShell's Get-FileHash cmdlet to retrieve the hash of the specified file.
    It then compares the retrieved hash against the provided hash. If the two hashes match, the function returns $true,
    otherwise it returns $false.

  .PARAMETER Hash
    A string containing the expected MD5 hash value

  .PARAMETER File
    A string containing the path to the file to be compared

  .EXAMPLE
    Compare-IsValidHash -Hash "1234567890ABCDEF" -File "C:\path\to\file.txt"

    If the MD5 hash of "C:\path\to\file.txt" is "1234567890ABCDEF", this function will return $true. Otherwise it will return $false.

  .OUTPUTS
    Boolean
  #>
  [CmdletBinding()]
  param ($Hash, $File)
  
  # retrieve the hash of the specified file
  $_hash = ((Get-FileHash $File -Algorithm MD5 | 
      Select-Object Hash) -split " ").Trim("@{Hash=}")
      
  # compare the retrieved hash against the provided hash
  if ($_hash -ne $Hash) { return $false }
  else { return $true }
}

function Format-Text {
  <#
  .SYNOPSIS
    Writes text with color and formatting

  .DESCRIPTION
    Writes text with color, formatting and RGB support
  
  .INPUTS
    This function accepts pipeline input.

  .PARAMETER Text
    The text to be written

  .PARAMETER Foreground
    The foreground color of the text to be written.
    Accepts a valid color name, 8-bit 0-255 integer value, 24-bit RGB 0,0,0 format.

  .PARAMETER Background
    The background color of the text to be written.
    Accepts a valid color name, 8-bit 0-255 integer value, 24-bit RGB 0,0,0 format.

  .PARAMETER Formatting
    The text formatting options to be applied to the text.
    Accepts a list of valid formatting options:
      - Bold
      - Dim
      - Underline
      - Blink
      - Reverse
      - Hidden

  .PARAMETER BitDepth
    The bit depth of the text to be written.
    Accepts values: 8 or 24
  
  .EXAMPLE
    Format-Text -Text "This is some red text on a black background" -Foreground Red -Background Black
  
  .EXAMPLE
    Write-Host "This text: $(Format-Text -Text "is green and underlined" -Foreground Green -Formatting Bold, Underline). Cool right?"


  .EXAMPLE
    Format-Text -Console -Foreground Blue -Background White
    
    This example shows how to change the color of the console.

  .EXAMPLE
    "Lorem ipsum dolor sit amet" | Format-Text -BitDepth 8 -Foreground 166 -Formatting Bold
    
    "Lorem ipsum dolor sit amet" | Format-Text -BitDepth 24 -Foreground 12,66,34 -Formatting Underline

    This example shows how to pipe text to the function with color in 8 and 24 bit depth.

  .NOTES
    8-bit color format:
    
    ESC[38;5;⟨n⟩m Select foreground color, where `n` is a number from the table below
    ESC[48;5;⟨n⟩m Select background color, where `n` is a number from the table below
    
        0-7:  standard colors (as in ESC [ 30-37 m)
      8-15:  high intensity colors (as in ESC [ 90-97 m)
    16-231:  6 × 6 × 6 cube (216 colors): 16 + 36 × r + 6 × g + b (0 ≤ r, g, b ≤ 5)
    232-255:  grayscale from dark to light in 24 steps


    RGB color format:

    ESC[38;2;⟨r⟩;⟨g⟩;⟨b⟩ m Select RGB foreground color
    ESC[48;2;⟨r⟩;⟨g⟩;⟨b⟩ m Select RGB background color

  .NOTES
    Filename: Format-Text.ps1
    Version: 1.3
    Author:  neuralpain
    Created: 2024-03-17
    Updated: 2024-04-20

    Version history:

    1.0  -  Initial release
    
    1.1  -  Add complete color set for both foreground and background

    1.2  -  Add support for 8-bit and 24-bit colors

    1.3  -  Add proper support for Light and Dark colors on Forground and Background; and fixed bug on text formatting
  #>
  [CmdletBinding()]
  param(
    [switch]$Console,
    [switch]$ConsoleReset, # unavailable on for now
    [Parameter(Position = 0, Mandatory = $false, HelpMessage = "The text to be written", ValueFromPipeline = $true)]
    [String]$Text,
    [Parameter(Mandatory = $false, HelpMessage = "The bit depth of the text to be written")]
    [ValidateSet(8, 24)]
    [Int]$BitDepth,
    [Parameter(Mandatory = $false, HelpMessage = "The foreground color of the text to be written")]
    [ValidateCount(1, 3)]
    [String[]]$Foreground,
    [Parameter(Mandatory = $false, HelpMessage = "The background color of the text to be written")]
    [ValidateCount(1, 3)]
    [String[]]$Background,
    [Parameter(Mandatory = $false, HelpMessage = "The text formatting options to be applied to the text")]
    [String[]]$Formatting
  )
  
  $Esc = [char]27
  $Reset = "${Esc}[0m"

  if ($Console) {
    # Set the foreground color
    $Host.UI.RawUI.ForegroundColor = $Foreground
    # Set the background color
    $Host.UI.RawUI.BackgroundColor = $Background
    # Clear the screen to apply the changes
    Clear-Host
    return
  }

  switch ($BitDepth) {
    8 {
      # if the value is less than 0, set it to 0
      if ($null -eq $Foreground -or $Foreground -lt 0) { $Foreground = 0 }
      if ($null -eq $Background -or $Background -lt 0) { $Background = 0 }
      
      # if the value is greater than 255, set it to 255
      if ($Foreground -gt 255) { $Foreground = 255 }
      if ($Background -gt 255) { $Background = 255 }

      $Foreground = "${Esc}[38;5;${Foreground}m"
      $Background = "${Esc}[48;5;${Background}m"
      break
    }
    24 {
      foreach ($color in $Foreground) {
        if ($null -eq $color -or $color -lt 0) { $color = 0 }
        if ($color -gt 255) { $color = 255 }
        $_foreground += ";${color}"
      }
      
      foreach ($color in $Background) {
        if ($null -eq $color -or $color -lt 0) { $color = 0 }
        if ($color -gt 255) { $color = 255 }
        $_background += ";${color}"
      }

      $Foreground = "${Esc}[38;2${_foreground}m"
      $Background = "${Esc}[48;2${_background}m"
      break
    }
    default {
      # Text Color:
      switch ($Foreground) { 
        'Black'        { $Foreground = "${Esc}[30m"  }
        'DarkRed'      { $Foreground = "${Esc}[31m"  }
        'DarkGreen'    { $Foreground = "${Esc}[32m"  }
        'DarkYellow'   { $Foreground = "${Esc}[33m"  }
        'DarkBlue'     { $Foreground = "${Esc}[34m"  }
        'DarkMagenta'  { $Foreground = "${Esc}[35m"  }
        'DarkCyan'     { $Foreground = "${Esc}[36m"  }
        'Gray'         { $Foreground = "${Esc}[37m"  }
        'DarkGray'     { $Foreground = "${Esc}[90m"  }
        'Red'          { $Foreground = "${Esc}[91m"  }
        'Green'        { $Foreground = "${Esc}[92m"  }
        'Yellow'       { $Foreground = "${Esc}[93m"  }
        'Blue'         { $Foreground = "${Esc}[94m"  }
        'Magenta'      { $Foreground = "${Esc}[95m"  }
        'Cyan'         { $Foreground = "${Esc}[96m"  }
        'White'        { $Foreground = "${Esc}[97m"  }
        default        { $Foreground = ""            }
      }
      # Background Color:
      switch ($Background) {
        'Black'        { $Background = "${Esc}[40m"  }
        'DarkRed'      { $Background = "${Esc}[41m"  }
        'DarkGreen'    { $Background = "${Esc}[42m"  }
        'DarkYellow'   { $Background = "${Esc}[43m"  }
        'DarkBlue'     { $Background = "${Esc}[44m"  }
        'DarkMagenta'  { $Background = "${Esc}[45m"  }
        'DarkCyan'     { $Background = "${Esc}[46m"  }
        'Gray'         { $Background = "${Esc}[47m"  }
        'DarkGray'     { $Background = "${Esc}[100m" }
        'Red'          { $Background = "${Esc}[101m" }
        'Green'        { $Background = "${Esc}[102m" }
        'Yellow'       { $Background = "${Esc}[103m" }
        'Blue'         { $Background = "${Esc}[104m" }
        'Magenta'      { $Background = "${Esc}[105m" }
        'Cyan'         { $Background = "${Esc}[106m" }
        'White'        { $Background = "${Esc}[107m" }
        default        { $Background = ""            }
      }
      break
    }
  }

  # Text Formatting:
  if ($Formatting.Length -eq 0) {
    $Format = ""
  }
  else { 
    $i = 0
    $Format = "${Esc}["
    foreach ($type in $Formatting) {
      switch ($type) {
        'Bold'      { $Format += "1" }
        'Dim'       { $Format += "2" }
        'Underline' { $Format += "4" }
        'Blink'     { $Format += "5" }
        'Reverse'   { $Format += "7" }
        'Hidden'    { $Format += "8" }
        default     { $Format += ""  }
      }
      $i++
      if ($i -lt ($Formatting.Length)) { $Format += ";" } 
      else { $Format += "m"; break }
    }
  }
  
  $OutString = "${Foreground}${Background}${Format}${Text}${Reset}"
  Write-Output $OutString
}

function Invoke-URLInDefaultBrowser {
  <#
  .SYNOPSIS
    Cmdlet to open a URL in the User's default browser.
    
  .DESCRIPTION
    Cmdlet to open a URL in the User's default browser.
    
  .PARAMETER URL
    Specify the URL to be Opened.
    
  .EXAMPLE
    PS> Invoke-URLInDefaultBrowser -URL 'http://jkdba.com'
      
    This will open the website "jkdba.com" in the user's default browser.
    
  .NOTES
    This cmdlet has only been test on Windows 10, using edge, chrome, and firefox as default browsers.
  #>
  [CmdletBinding()]
  param (
    [Parameter(Position = 0, Mandatory = $true)]
    [ValidateNotNullOrEmpty()]
    [String] $URL
  )
  # Verify Format. Do not want to assume http or https so throw warning.
  if ( $URL -notmatch "http://*" -and $URL -notmatch "https://*") {
    Write-Warning -Message "The URL Specified is formatted incorrectly: ($URL)" 
    Write-Warning -Message "Please make sure to include the URL Protocol (http:// or https://)"
    break;
  }
  # Replace spaces with encoded space
  $URL = $URL -replace ' ', '%20'
    
  # Get Default browser
  $DefaultSettingPath = 'HKCU:\SOFTWARE\Microsoft\Windows\Shell\Associations\UrlAssociations\http\UserChoice'
  $DefaultBrowserName = (Get-Item $DefaultSettingPath | Get-ItemProperty).ProgId
    
  # Handle for Edge
  # edge will no open with the specified shell open command in the HKCR.
  if ($DefaultBrowserName -eq 'AppXq0fevzme2pys62n3e0fbqa7peapykr8v') {
    # Open url in edge
    start Microsoft-edge:$URL 
  }
  else {
    try {
      # Create PSDrive to HKEY_CLASSES_ROOT
      $null = New-PSDrive -PSProvider registry -Root 'HKEY_CLASSES_ROOT' -Name 'HKCR'
      # Get the default browser executable command/path
      $DefaultBrowserOpenCommand = (Get-Item "HKCR:\$DefaultBrowserName\shell\open\command" | Get-ItemProperty).'(default)'
      $DefaultBrowserPath = [regex]::Match($DefaultBrowserOpenCommand, '\".+?\"')
      # Open URL in browser
      Start-Process -FilePath $DefaultBrowserPath -ArgumentList $URL   
    }
    catch {
      Throw $_.Exception
    }
    finally {
      # Clean up PSDrive for 'HKEY_CLASSES_ROOT
      Remove-PSDrive -Name 'HKCR'
    }
  }
}

function New-ToastNotification {
  <#
  .SYNOPSIS
    Creates and displays a Windows Toast notification

  .DESCRIPTION
    Creates a Windows Toast notification and displays it to the user.

  .PARAMETER ToastTitle
    The title of the Toast notification

  .PARAMETER ToastText
    The text of the Toast notification

  .EXAMPLE
    New-ToastNotification "Hello World" "This is a Toast notification"

    Creates and displays a Toast notification with the title "Hello World" and the text "This is a Toast notification"

  .NOTES
    The function requires Windows 10 build 10586 (Anniversary Update) or higher
  #>
  [CmdletBinding()]
  param(
    [String]
    $ToastTitle,
    [String]
    [parameter(ValueFromPipeline)]
    $ToastText
  )
  
  # don't allow toast notifications on operating systems below Windows 10
  if (((Get-WmiObject -Class Win32_OperatingSystem).Version.Split('.')[0]) -lt 10) { return }

  [Windows.UI.Notifications.ToastNotificationManager, Windows.UI.Notifications, ContentType = WindowsRuntime] > $null
  $Template = [Windows.UI.Notifications.ToastNotificationManager]::GetTemplateContent([Windows.UI.Notifications.ToastTemplateType]::ToastText02)

  $RawXml = [xml] $Template.GetXml()
  ($RawXml.toast.visual.binding.text | Where-Object { $_.id -eq "1" }).AppendChild($RawXml.CreateTextNode($ToastTitle)) > $null
  ($RawXml.toast.visual.binding.text | Where-Object { $_.id -eq "2" }).AppendChild($RawXml.CreateTextNode($ToastText)) > $null

  $SerializedXml = New-Object Windows.Data.Xml.Dom.XmlDocument
  $SerializedXml.LoadXml($RawXml.OuterXml)

  $Toast = [Windows.UI.Notifications.ToastNotification]::new($SerializedXml)
  $Toast.Tag = "PowerShell"
  $Toast.Group = "PowerShell"
  $Toast.ExpirationTime = [DateTimeOffset]::Now.AddMinutes(1)
  
  $Notifier = [Windows.UI.Notifications.ToastNotificationManager]::CreateToastNotifier("PowerShell")
  $Notifier.Show($Toast);
}

function Show-WebRequestDownloadJobState {
  <#
  .SYNOPSIS
    Display a simple animation while waiting for a download job to complete.
  
  .DESCRIPTION
    Waits for a download job to complete, displaying a
    progress bar while it is running. When the download is complete, the
    function will write a completion message to the console.
  
  .PARAMETER DownloadJob
    The download job to wait for
    
  .PARAMETER Message
    The message to display while the download is in progress

  .EXAMPLE
    Show-WebRequestDownloadJobState -DownloadJob $DownloadJob -Message "Downloading from host"

    Waits for the download job to complete
  
  .EXAMPLE
    $Job = Start-Job -ScriptBlock { Invoke-WebRequest -Uri "https://www.gutenberg.org/cache/epub/1184/pg1184.txt" -OutFile "TheRoadNotTaken.txt" }
    Show-WebRequestDownloadJobState -DownloadJob $Job  -Message "Downloading from host"

    Waits for the download job to complete

  .EXAMPLE
    Start-Job -ScriptBlock {
      Invoke-WebRequest -Uri "https://www.gutenberg.org/cache/epub/1184/pg1184.txt" -OutFile "TheRoadNotTaken.txt"
    } | Show-WebRequestDownloadJobState -Message "Downloading from host"

    Waits for the download job to complete

  .NOTES
    Filename: Show-WebRequestDownloadJobState.ps1
    Version 1.2
    Author: neuralpain
    Created: 2024-03-16
    Updated: 2024-03-19

    Version history:
  
    1.0  -  Initial release with basic functionality
  
    1.1  -  Bug fixes
  
    1.2  -  Change text color
  #>
  [CmdletBinding()]
  param(
    [Parameter(Mandatory = $true, ValueFromPipeline = $true)]
    $DownloadJob,
    [Parameter(Mandatory = $true)]
    [String]$Message,
    [scriptblock]$CompleteScript,
    [scriptblock]$FailedScript,
    [scriptblock]$StoppedScript
  )
  
  $Padding = " " * ($Message.Length + 12)

  while ($DownloadJob.State -eq 'Running') {
    Write-Host -NoNewLine "`r[*....] $($Message)..." -ForegroundColor White
    Start-Sleep -Milliseconds 100
    Write-Host -NoNewLine "`r[.*...] $($Message)..." -ForegroundColor White
    Start-Sleep -Milliseconds 100
    Write-Host -NoNewLine "`r[..*..] $($Message)..." -ForegroundColor White
    Start-Sleep -Milliseconds 100
    Write-Host -NoNewLine "`r[...*.] $($Message)..." -ForegroundColor White
    Start-Sleep -Milliseconds 100
    Write-Host -NoNewLine "`r[....*] $($Message)..." -ForegroundColor White
    Start-Sleep -Milliseconds 100
    Write-Host -NoNewLine "`r[.....] $($Message)..." -ForegroundColor White
    Start-Sleep -Milliseconds 100
  }

  # Clear the progress bar
  Write-Host -NoNewLine "`r${Padding}`r"
  
  # if the variable contains a script block, execute it
  switch ($DownloadJob.State) {
    'Completed' { 
      if ($CompleteScript -eq $null) { Write-Host ":: Download completed successfully.${Padding}" -ForegroundColor Green; break } 
      # if not, write a success message
      else { &$CompleteScript }
    }
    'Failed' { 
      if ($FailedScript -eq $null) { Write-Host ":: Failed to download from host.${Padding}" -ForegroundColor Red; break }
      # if not, write a failure message
      else { &$FailedScript }
    }
    'Stopped' { 
      if ($StoppedScript -eq $null) { Write-Host ":: Download was manually stopped.${Padding}" -ForegroundColor Red; break }
      # if not, write a failure message
      else { &$StoppedScript }
    }
  }
}

function Get-TimeToComplete {
  param ([int]$DownloadSize, [int]$Bandwidth)
    
  [double]$time = ($DownloadSize / $Bandwidth)
  [int]$time = [math]::Round($time)
  
  $Script:RAW_DOWNLOAD_TIME = $time
  
  if ($time -gt 60) {
    [int]$time_m = $time / 60
    [int]$time_s = $time % 60
    return "${time_m}m${time_s}s"
  }
  
  return "$time seconds"
}

function Compare-InstallerDownloadSize {  
  # clean up uncompleted donwnload
  if (-not(Compare-IsValidHash -File $Script:SELECTED_QB_OBJECT.Name -Hash $Script:SELECTED_QB_OBJECT.Hash)) {
    # Write-Host $Script:SELECTED_QB_OBJECT.Name            # Debug
    Remove-Item $Script:SELECTED_QB_OBJECT.Name
  }
}

function Select-QuickBooksVersion {
  <#
  .NOTES
    Triggered by `Write-Menu_VersionSelection`
  #>
  if ($null -ne $Script:QB_VERSION) {
    Write-Host "Already selected version: $(Get-Version)"
    Write-Host "Clear selection?"
    $query = Read-Host "Y/n"
    switch ($query) {
      "Y" { Set-Version $null }
      default { break } # do nothing and return to menu
    }
  }
  
  while ($null -eq $Script:QB_VERSION) {
    Write-Menu_VersionSelection
    switch (Get-Version) {
      "" { break }
      0 {
        Write-Action_OperationCancelled
        Set-Version $null
        return
      }
      default {
        if ($qbVersionList -notcontains $Script:QB_VERSION) {
          Write-Host "Invalid option `"${version}`"" -ForegroundColor Red
          Set-Version $null
          Start-Sleep -Milliseconds $TIME_BLINK
          break
        }
        else { return }
      }
    }
  }
}

function Get-QuickBooksObject {
  <#
  .SYNOPSIS
    Downloads the QuickBooks POS installer from the internet.
  
  .DESCRIPTION
    This function is the first function called by the Install-QuickBooksPOS function.
    It gets the QuickBooks POS installer from the internet.
  
  .NOTES
    Linked to Install-QuickBooksPOS
  #>
  if ($null -eq $Script:QB_VERSION) { Write-Menu_SubMenu } 
  else {
    switch (Get-Version) {
      $POS19InstObj.VerNum { $Script:SELECTED_QB_OBJECT = $POS19InstObj }
      $POS18InstObj.VerNum { $Script:SELECTED_QB_OBJECT = $POS18InstObj }
      $POS12InstObj.VerNum { $Script:SELECTED_QB_OBJECT = $POS12InstObj }
      $POS11InstObj.VerNum { $Script:SELECTED_QB_OBJECT = $POS11InstObj }
    }

    $Script:INSTALLER_SIZE = $Script:SELECTED_QB_OBJECT.Size
    $Script:INSTALLER_BYTES = $Script:SELECTED_QB_OBJECT.XByte
    $Script:INSTALLER_BITS = $Script:SELECTED_QB_OBJECT.XBits
  }
}

function Start-InstallerDownload {
  <#
  .SYNOPSIS
  Downloads the QuickBooks POS installer from the internet.

  .DESCRIPTION
  This function starts the download of the QuickBooks POS installer
  from the internet. The download progress is displayed in the console
  and estimated time of completion is calculated based on the user's
  internet speed.
  #>  
  Clear-Terminal
  Write-Host " Downloading POS v$($Script:SELECTED_QB_OBJECT.VerNum), $($Script:INSTALLER_SIZE)MB... " -ForegroundColor White -BackgroundColor DarkCyan
  New-ToastNotification -ToastText "Downloading POS v$($Script:SELECTED_QB_OBJECT.Name), $($Script:INSTALLER_SIZE)MB..." -ToastTitle "Download started"
  
  if (-not($Script:BANDWIDTH_UNKNOWN)) {
    $estimated_download_time = Get-TimeToComplete $Script:INSTALLER_BITS $Script:BANDWIDTH_BITS
    Write-Host "`nDST: $($Script:TARGET_LOCATION)`nETC: $estimated_download_time @ $($Script:BANDWIDTH) Mbps" -ForegroundColor White
  }
  else {
    Write-Host "`nDST: $($Script:TARGET_LOCATION)`nETC: UNKNOWN_DURATION @ >0.01 Mbps" -ForegroundColor White
  }
  
  Write-Host "`nEstimated time is calculated from the point that your`ninternet speed was tested. This is just an estimation and`nmay not reflect the actual time that it would take for the`ndownload to complete on your system. This is subject to`nchange as your internet speed fluctuates."
  Write-Host "`nPlease wait while the installer is being downloaded.`nThe installer will be started automatically after the`ndownload is complete.`n" -ForegroundColor Yellow
  
  $installer_download_path = "$($Script:TARGET_LOCATION)\$($Script:SELECTED_QB_OBJECT.Name)"
  $installer_download_url = "$($Script:SELECTED_QB_OBJECT.Url)"

  $installer_download_job = Start-Job -ScriptBlock {
    param($url, $Destination)
    try { 
      Invoke-WebRequest -Uri $url -OutFile $Destination
      New-ToastNotification -ToastText "Successfully downloaded $($Script:SELECTED_QB_OBJECT.Name)." -ToastTitle "Download complete"
    }
    catch { Write-Host "Error: $_" -ForegroundColor Red }
    finally { Compare-InstallerDownloadSize }
  } -ArgumentList $installer_download_url, $installer_download_path
  
  Show-WebRequestDownloadJobState -DownloadJob $installer_download_job -Message "Downloading installer"
  
  # Write-Host $installer_download_path                      # Debug
  Wait-Job $installer_download_job >$null 2>&1
  Remove-Job $installer_download_job
  # Pause                                                    # Debug  
}

function Write-License {
  param([String]$LNumber, [String]$PNumber)
  return '<Registration InstallDate="" LicenseNumber="', $LNumber, '" ProductNumber="', $PNumber, '"/>' -join ''
}

function Get-UserOwnLicense {
  <#
  .NOTES
    Triggered by `Write-LieResponse`
  #>
  Clear-Terminal
  Write-Host "Enter a valid license below`n" -ForegroundColor White -BackgroundColor DarkCyan
  Write-Host "A valid license pattern: 0000-0000-0000-000" -ForegroundColor White
  Write-Host "A valid product key pattern: 000-000`n" -ForegroundColor White

  $custom_license_number = Read-Host "License"
  $custom_product_number = Read-Host "Product Key"
  
  Write-Host "`nIs this license information correct? (Y/n): " -ForegroundColor Yellow -NoNewline
  $query = Read-Host

  switch ($query) {
    "n" { Get-UserOwnLicense }
    default { break }
  }

  if ($custom_license_number.Length -lt 18 -or $custom_license_number.Length -gt 18 -or $custom_product_number.Length -lt 7 -or $custom_product_number.Length -gt 7) { 
    Clear-Terminal
    Write-Host "`nLicense is invalid" -ForegroundColor White -BackgroundColor DarkRed
    Write-Host "`nCheck your license and try again." -ForegroundColor White
    $query = Read-Host "`nTry again? (y/N)"
    Write-Host -NoNewLine "Selected: $query"; Write-Host -NoNewLine "`r                              `r" # To transcript # Debug
    switch ($query) {
      "y" { Get-UserOwnLicense; break }
      default { $Script:RUN_NEXT_PROCEDURE = $null; break }
    }
  }
  
  Set-License (Write-License $custom_license_number $custom_product_number)
  $Script:CUSTOM_LICENSING = $true
}

function Install-IntuitLicense {
  Clear-IntuitData
  Write-Host -NoNewLine "Installing registration keys... "
  
  switch (Get-Version) {
    $POS19InstObj.VerNum {
      $path = $POS19InstObj.Path
      mkdir $env:ProgramData\$path >$null 2>&1
      Out-File -FilePath $env:ProgramData\$path\qbregistration.dat `
               -InputObject (Get-License) `
               -Encoding UTF8 `
               -NoNewline
    }
    
    $POS18InstObj.VerNum {
      $path = $POS18InstObj.Path
      mkdir $env:ProgramData\$path >$null 2>&1
      Out-File -FilePath $env:ProgramData\$path\qbregistration.dat `
               -InputObject (Get-License) `
               -Encoding UTF8 `
               -NoNewline
    }
    
    $POS12InstObj.VerNum {
      $path = $POS12InstObj.Path
      mkdir $env:ProgramData\$path >$null 2>&1
      Out-File -FilePath $env:ProgramData\$path\qbregistration.dat `
               -InputObject (Get-License) `
               -Encoding UTF8 `
               -NoNewline
    }

    $POS11InstObj.VerNum {
      $path = $POS11InstObj.Path
      mkdir $env:ProgramData\$path >$null 2>&1
      Out-File -FilePath $env:ProgramData\$path\qbregistration.dat `
               -InputObject (Get-License) `
               -Encoding UTF8 `
               -NoNewline
    }
  }
  
  # Pause # Debug
  Write-Host "Done"
}

function Get-IntuitLicense {
  param ($Hash)
  
  switch ($Hash) {
    $POS19InstObj.Hash {
      Set-Version $POS19InstObj.VerNum
      $Script:INSTALLER_SIZE = $POS19InstObj.Size
      $Script:INSTALLER_BYTES = $POS19InstObj.XByte
      
      if ($Script:CUSTOM_LICENSING) {
        return
      } elseif ($Script:SECOND_STORE) {
        Set-License (Write-License -LNumber $POS19InstObj.LNum2 -PNumber $POS19InstObj.PNum)
      } elseif ($Script:ADDITIONAL_CLIENTS) {
        $_license = ($pos19_licenses | Get-Random)
        Set-License (Write-License -LNumber $_license -PNumber $POS19InstObj.PNum)
      } else {
        Set-License (Write-License -LNumber $POS19InstObj.LNum1 -PNumber $POS19InstObj.PNum)
      }
    }

    $POS18InstObj.Hash {
      Set-Version $POS18InstObj.VerNum
      $Script:INSTALLER_SIZE = $POS18InstObj.Size
      $Script:INSTALLER_BYTES = $POS18InstObj.XByte

      if ($Script:CUSTOM_LICENSING) {
        return
      } elseif ($Script:SECOND_STORE) {
        Set-License (Write-License -LNumber $POS18InstObj.LNum2 -PNumber $POS18InstObj.PNum)
      } elseif ($Script:ADDITIONAL_CLIENTS) {
        $_license = ($pos18_licenses | Get-Random)
        Set-License (Write-License -LNumber $_license -PNumber $POS18InstObj.PNum)
      } else {
        Set-License (Write-License -LNumber $POS18InstObj.LNum1 -PNumber $POS18InstObj.PNum)
      }
    }

    $POS12InstObj.Hash {
      Set-Version $POS12InstObj.VerNum
      $Script:INSTALLER_SIZE = $POS12InstObj.Size
      $Script:INSTALLER_BYTES = $POS12InstObj.XByte

      if ($Script:CUSTOM_LICENSING) {
        return
      } elseif ($Script:SECOND_STORE) {
        Set-License (Write-License -LNumber $POS12InstObj.LNum2 -PNumber $POS12InstObj.PNum)
      } elseif ($Script:ADDITIONAL_CLIENTS) {
        $_license = ($pos12_licenses | Get-Random)
        Set-License (Write-License -LNumber $_license -PNumber $POS12InstObj.PNum)
      } else {
        Set-License (Write-License -LNumber $POS12InstObj.LNum1 -PNumber $POS12InstObj.PNum)
      }
    }
    
    $POS11InstObj.Hash {
      Set-Version $POS11InstObj.VerNum
      $Script:INSTALLER_SIZE = $POS11InstObj.Size
      $Script:INSTALLER_BYTES = $POS11InstObj.XByte

      if ($Script:CUSTOM_LICENSING) {
        return
      } elseif ($Script:SECOND_STORE) {
        Set-License (Write-License -LNumber $POS11InstObj.LNum2 -PNumber $POS11InstObj.PNum)
      } elseif ($Script:ADDITIONAL_CLIENTS) {
        $_license = ($pos11_licenses | Get-Random)
        Set-License (Write-License -LNumber $_license -PNumber $POS11InstObj.PNum)
      } else {
        Set-License (Write-License -LNumber $POS11InstObj.LNum1 -PNumber $POS11InstObj.PNum)
      }
    }
  }
}

function Invoke-QuickBooksInstaller {  
  if ($Script:INSTALLER_AVAILABLE) {
    Start-Installer .\$Script:INSTALLER_OBJECT
  }
  else {
    Write-Host "A QuickBooks POS installer was not found." -ForegroundColor Yellow
    New-ToastNotification -ToastText "A QuickBooks POS installer was not found." -ToastTitle "Installer not found"
    Start-Sleep -Milliseconds $TIME_SLOW
    $Script:RUN_NEXT_PROCEDURE = $null
    return
  }
}

function Start-Installer {
  param ($Installer)
  # clear temporary installation files from previous 
  # installer launch and start a new installation process
  Remove-Item $intuit_temp -Recurse -Force >$null 2>&1
  Write-WaitingScreen
  
  try { 
    New-ToastNotification -ToastText "Installing QuickBooks POS..." -ToastTitle "qbactivator"
    Start-Process -FilePath $Installer -Wait 
  }
  catch { Write-Error_CannotStartInstaller }
  
}


# verify that the patch was successful
$VerifyClientModulePatch = {
  if (Compare-IsValidHash -File "$CLIENT_MODULE_FULL_PATH" -Hash $PATCH_HASH) {
    Write-Host "Patch successful."
  }
  else {
    Write-Host "Unable to patch POS."; Pause
    Invoke-NextProcess $PROC_RETURN_MAIN
  }
}

function Get-ClientModule {
  param ($Local, $FromHostUrl)
  # check if the local file exists
  if ($Local) {
    if (Test-Path $Local -PathType Leaf) {
      Copy-Item $Local $CLIENT_MODULE_FULL_PATH
      return
    }
  }
  
  Write-Host "Local file not found."
  # if its a host request only
  &$TestInternetAvailable
  Write-Host "Downloading, please wait..."
  Start-BitsTransfer $FromHostUrl $CLIENT_MODULE_FULL_PATH
  New-ToastNotification -ToastText "Client module downloaded." -ToastTitle "Download complete"
  return
}

function Install-ClientModule {
  Write-Host "Patching client module... "
  Rename-Item $CLIENT_MODULE_FULL_PATH "${CLIENT_MODULE_FULL_PATH}.bak" >$null 2>&1
  # attempt to patch with the local patch file first
  if (Test-Path "$LOCAL_PATCH_FILE" -PathType Leaf) {
    $isValid = Compare-IsValidHash -Hash $PATCH_HASH -File $LOCAL_PATCH_FILE
    if ($isValid) { Copy-Item $LOCAL_PATCH_FILE $CLIENT_MODULE_FULL_PATH } 
    else { 
      Write-Host "`nPatch file may be corrupted."
      Get-ClientModule -FromHostUrl $CLIENT_FILE_ON_HOST
      &$VerifyClientModulePatch # call back and verify that the patch was successful
    }
  }
  else { 
    Get-ClientModule -FromHostUrl $CLIENT_FILE_ON_HOST
    &$VerifyClientModulePatch # call back and verify that the patch was successful
  }
}

function Start-PosActivation {
  Clear-Terminal
  
  if ($Script:QUICKBOOKS_IS_INSTALLED) {
    Stop-QuickBooksProcesses
    # check for any errors with the client module
    Repair-LevelOne_GenuineClientModule
  }
  else {
    Write-Error_QuickBooksNotInstalled
    Invoke-NextProcess $PROC_RETURN_MAIN
  }

  Install-ClientModule # inject modified client module
  Write-Host "Proceeding with activation..."
  Start-Sleep -Milliseconds $TIME_SLOW
}

function Repair-LevelOne_GenuineClientModule {
  <#
  .SYNOPSIS
    Check if the .bak file exists
  #>
  if (Test-Path "${CLIENT_MODULE_FULL_PATH}.bak" -PathType Leaf) {
    Write-Host "Lv1: Fixing error on client module... "
    Remove-Item $CLIENT_MODULE_FULL_PATH -Force >$null 2>&1
    Rename-Item "${CLIENT_MODULE_FULL_PATH}.bak" $CLIENT_MODULE_FULL_PATH >$null 2>&1
    # check if the `.bak` file was successfully removed, else escalate to Lv2
    if (Test-Path "${CLIENT_MODULE_FULL_PATH}.bak" -PathType Leaf) {
      Write-Host "Lv1: Unable to resolve error."
      Write-Host "Lv1: Escalating to Lv2..."
      Start-Sleep -Milliseconds $TIME_SLOW
      Repair-LevelTwo_GenuineClientModule_SanityCheck
    } else {
      # notify the user that the client module was successfully repaired
      New-ToastNotification -ToastText "Lv1: Client module restored." -ToastTitle "Client Module Repair"
    }
  }
  else {
    Write-Host "Lv1: Modified client module was not found."
    Start-Sleep -Milliseconds $TIME_SLOW
  }
}

function Repair-LevelTwo_GenuineClientModule_SanityCheck {
  <#
  .SYNOPSIS
    Check if the client file is the genuine one and make any additional repairs. Will only run if this is requested.
  #>
  param([switch]$SanityCheck)
  # if a client module is found on the system then, do a comparison with the PATCH_HASH for genuineity
  if ($SanityCheck) { Write-Host "Lv2: Performing a sanity check..." }
  
  if (Test-Path $CLIENT_MODULE_FULL_PATH -PathType Leaf) {
    Write-Host "Lv2: Found a client module."
    # if the comparison returns true, then this client module was modified
    if ((Compare-IsValidHash -File $CLIENT_MODULE_FULL_PATH -Hash $PATCH_HASH)) {
      Write-Host "Lv2: Client module is modified. Repairing..."
      # remove client files
      Remove-Item "$CLIENT_MODULE_PATH\*" -Force >$null 2>&1
      # fix this error by using the LOCAL_GENUINE_FILE on user system to repair, if this is available
      # if a LOCAL_GENUINE_FILE is not found, then download it from the host
      Get-ClientModule -Local $LOCAL_GENUINE_FILE -FromHostUrl $GENUINE_CLIENT_FILE_ON_HOST
    }
    else {
      # if the comparison with PATCH_HASH returns false, then there is no issue
      Write-Host "Lv2: No issues found. Nothing to repair."
      Start-Sleep -Milliseconds $TIME_SLOW
      return
    }
  }
  else {
    # if no client module is found on the system, then download it from the host
    Write-Host "Lv2: No client module found. Retrieving..."
    Get-ClientModule -Local $LOCAL_GENUINE_FILE -FromHostUrl $GENUINE_CLIENT_FILE_ON_HOST
    # remove the `.bak` file, if it exists
    if (Test-Path "${CLIENT_MODULE_FULL_PATH}.bak" -PathType Leaf) { 
      Remove-Item "${CLIENT_MODULE_FULL_PATH}.bak" -Force >$null 2>&1
      Write-Host "Lv2: Removed unusable client module backup."
    }
  }
  # ----------------------------------------------------
  # check if the client module was repaired successfully
  if ((Compare-IsValidHash -File $CLIENT_MODULE_FULL_PATH -Hash $PATCH_HASH)) {
    Write-Host "Lv2: Unable to repair the client module." # create fullscreen prompt for this
    # notify the user that the client module was not repaired
    New-ToastNotification -ToastText "Lv2: Unable to repair the client module." -ToastTitle "Client Module Repair"
  }
  else {
    Write-Host "Lv2: Client module repaired successfully."
    # notify the user that the client module was successfully repaired
    New-ToastNotification -ToastText "Lv2: Client module repaired successfully." -ToastTitle "Client Module Repair"
    Start-Sleep -Milliseconds $TIME_SLOW
  }
}

function Repair-LevelThree_Reactivation {
  # ensure the the quickbooks entitlement client is available for reactivation
  if (-not($Script:QUICKBOOKS_IS_INSTALLED)) {
    Write-Error_QuickBooksNotInstalled
    return
  }
  
  # 如 entitlement client 不在, 没问题，就创建新的
  if (-not(Test-Path $CLIENT_MODULE_DATA_PATH -PathType Container)) {
    Write-Host "Lv3: Data folder not found."
    New-Item $CLIENT_MODULE_DATA_PATH -ItemType Directory >$null 2>&1
    Write-Host "Lv3: Created new data folder."
    return
  }
  
  Write-Host -NoNewline "Lv3: Removing old activation data... "
  Remove-Item "$CLIENT_MODULE_DATA_PATH\*" -Force >$null 2>&1
  Write-Host "Done"

  New-ToastNotification -ToastText "Activation data has been cleared." -ToastTitle "Client Module Repair"
}

function Write-HeaderLabel {
  Clear-Terminal
  Format-Text " qbactivator `n" -Foreground White -Background DarkGreen -Formatting Bold
  
  # store selection information
  if ($Script:SECOND_STORE) {
    Write-Host "Workstation: $(Format-Text "Secondary Server" -Foreground DarkYellow)"
  } elseif ($Script:ADDITIONAL_CLIENTS) {
    Write-Host "Workstation: $(Format-Text "Additional Clients and Other" -Foreground DarkYellow)"
  } else {
    Write-Host "Workstation: $(Format-Text "Primary Server (Default)" -Foreground DarkYellow)"
  }
  
  # quickbooks installation status
  if ($Script:QUICKBOOKS_IS_INSTALLED) {
    Write-Host "QuickBooks POS: $(Format-Text "Installed" -Foreground Green)"
    Write-Host "Path: $(Format-Text "$($Script:QUICKBOOKS_INSTALLED_PATH)" -Foreground Green)"
  } else {
    Write-Host "QuickBooks POS: $(Format-Text "Not installed" -Foreground DarkYellow)"
    Write-Host "Path: $(Format-Text "Unavailable" -Foreground DarkYellow)"
  }  
  
  # pos version
  if (Get-Version -ne $null) {
    Write-Host "POS Version: $(Format-Text "POS v$(Get-Version)" -Foreground DarkYellow)"
  } elseif (-not($Script:QUICKBOOKS_IS_INSTALLED)) {
    Write-Host "POS Version: $(Format-Text "Unknown" -Foreground DarkYellow)"
  }

  Write-Host # break line
}

function Write-InfoLink {
  param([Switch]$WithFAQs, [Switch]$ReturnToMenu)
  Write-Host "`nFor more information, visit:" -ForegroundColor White
  Write-Host "https://github.com/neuralpain/qbactivator" -ForegroundColor Green
  if ($WithFAQs) { Write-Host "https://github.com/neuralpain/qbactivator/wiki/FAQs" -ForegroundColor Green }
  if ($ReturnToMenu) { $Script:RUN_NEXT_PROCEDURE = $null }
}

function Write-WaitingScreen {
  Write-HeaderLabel
  Write-Host "QuickBooks software installation in progress..." -ForegroundColor White
  Write-Host "`nPlease ensure that the QuickBooks software is completely`ninstalled on your system. Activation will proceed after`nthe installation is completed."
  Write-Host "`nIf you need to cancel the installation for any reason, `nplease close this window afterwards." -ForegroundColor Cyan
  Write-InfoLink
}

function Write-Action_ExitActivator {
  Write-Host "---"
  Write-Host "Exiting qbactivator..." -ForegroundColor Yellow
  Start-Sleep -Milliseconds $TIME_BLINK
}

function Write-Action_OperationCancelled {
  Write-Host "---"
  Write-Host "Operation cancelled by user." -ForegroundColor Yellow
  Start-Sleep -Milliseconds $TIME_BLINK
}

function Write-Action_OptionUnavailable {
  Write-Host "---"
  Write-Host "This option is disabled." -ForegroundColor Yellow
  Start-Sleep -Milliseconds $TIME_NORMAL
}

<#
  Menu Shortcuts / HotKeys
    100: Exit Qbactivator
    200: Open Troubleshooting Menu
    300: Open wiki
    500: Open logs
#>

function Write-Menu_Main {
  &$InitializeMain
  &$VerifyIfQuickBooksIsInstalled
  Write-HeaderLabel
  Write-Host "$(Format-Text "Select activation option" -Foreground Gray -Formatting Bold, Underline)`n"
  Write-Host "1 - POS Primary Server/Workstation"
  Write-Host "2 - POS Secondary Server/Workstation"
  Write-Host "3 - POS Client Workstations"
  Write-Host "4 - I have my own license :p"
  Write-Host "5 - Troubleshooting"
  Write-Host "6 - Refresh qbactivator"
  Write-Host "0 - Exit"
  $query = Read-Host "`n#"
  
  switch ($query) {
    0 { &$ExitQbactivator }
    10 { &$InvokeGeneralActivation }
    100 { &$ExitQbactivator }
    200 { Invoke-NextProcess $PROC_TROUBLESHOOT }
    300 { &$OpenWiki; Write-Menu_Main }
    500 { &$OpenLogs; Write-Menu_Main }
    1 {
      $Script:SECOND_STORE = $false
      $Script:ADDITIONAL_CLIENTS = $false
      Write-Menu_SubMenu 
    }
    2 {
      $Script:SECOND_STORE = $true
      $Script:ADDITIONAL_CLIENTS = $false
      Write-Menu_SubMenu
    }
    3 {
      $Script:SECOND_STORE = $false
      $Script:ADDITIONAL_CLIENTS = $true
      Write-Menu_SubMenu
    }
    4 {
      &$CheckQuickBooksIsInstalled_ReturnToMainMenu
      Write-LieResponse
      if ($null -eq $Script:RUN_NEXT_PROCEDURE) {
        Write-Menu_SubMenu
      }
    }
    5 {
      &$CheckQuickBooksIsNotInstalled_ReturnToMainMenu
      Invoke-NextProcess $PROC_TROUBLESHOOT
    }
    6 {
      &$InitializeMain
      &$VerifyIfQuickBooksIsInstalled    
      Invoke-NextProcess $PROC_RETURN_MAIN
    }
    default { Invoke-NextProcess $PROC_RETURN_MAIN }
  }
}

function Write-Menu_SubMenu {
  Write-HeaderLabel
  Write-Host "$(Format-Text "Select next operation" -Foreground Gray -Formatting Bold, Underline)`n"
  Write-Host "1 - Install & Activate"
  Write-Host "2 - Activate Only"
  Write-Host "3 - Install Only"
  Write-Host "4 - Download a POS installer"
  
  Write-Host "0 - Cancel"
  $query = Read-Host "`n#"
  Write-Host -NoNewLine "Selected: $query"; Write-Host -NoNewLine "`r                              `r" # To transcript # Debug
  switch ($query) {
    0 { 
      $Script:SECOND_STORE = $false
      $Script:ADDITIONAL_CLIENTS = $false
      Write-Menu_Main
      break
    }
    10 { &$InvokeGeneralActivation }
    100 { &$ExitQbactivator }
    200 { Invoke-NextProcess $PROC_TROUBLESHOOT }
    300 { &$OpenWiki; Write-Menu_SubMenu }
    500 { &$OpenLogs; Write-Menu_SubMenu }
    1 {
      &$CheckQuickBooksIsInstalled_ReturnToMainMenu
      Invoke-NextProcess $PROC_LICENSE
      break
    }
    2 {
      &$CheckQuickBooksIsNotInstalled_ReturnToMainMenu
      Invoke-NextProcess $PROC_ACTIVATE
      break
    }
    3 {
      $Script:QUICKBOOKS_INSTALL_ONLY = $true
      &$CheckQuickBooksIsInstalled_ReturnToMainMenu
      Invoke-NextProcess $PROC_LICENSE
      break
    }
    4 {
      $Script:INSTALLER_DOWNLOAD_ONLY = $true
      Invoke-NextProcess $PROC_DOWNLOAD
      break
    }
    default { Write-Menu_SubMenu; break }
  }
}

function Write-Menu_VersionSelection {
  Write-HeaderLabel
  Write-Host "$(Format-Text "Select QuickBooks POS verison" -Foreground Gray -Formatting Bold, Underline)`n"
  Write-Host "11 - QuickBooks POS 2013"
  Write-Host "12 - QuickBooks POS 2015"
  Write-Host "18 - QuickBooks POS 2018"
  Write-Host "19 - QuickBooks POS 2019"
  Write-Host "0 --- Cancel"
  $query = Read-Host "`nVersion"
  Set-Version $query

  # allow exit at any point in time
  switch ($query) {
    10 { &$InvokeGeneralActivation }
    100 { &$ExitQbactivator }
    200 { Invoke-NextProcess $PROC_TROUBLESHOOT }
    300 { &$OpenWiki; Write-Menu_VersionSelection }
    500 { &$OpenLogs; Write-Menu_VersionSelection }
  }
}

function Write-Menu_Troubleshooting {
  Write-HeaderLabel
  Write-Host "$(Format-Text "Select troubleshooting option" -Foreground Gray -Formatting Bold, Underline)`n"
  Write-Host "1 - Lv1 Client module: Restore"
  Write-Host "2 - Lv2 Client module: Repair"
  Write-Host "3 - Lv3 Client module: Re-activation"
  Write-Host "4 - Lv4 Re-install QuickBooks"
  Write-Host "5 - QuickBooks Patch Test"
  Write-Host "6 - View links to stuff"
  Write-Host "0 - Back"
  $query = Read-Host "`n#"
  Write-Host -NoNewLine "Selected: $query"; Write-Host -NoNewLine "`r                              `r" # To transcript # Debug
  switch ($query) {
    0 { Write-Menu_Main; break }
    10 { &$InvokeGeneralActivation }
    100 { &$ExitQbactivator }
    200 { Invoke-NextProcess $PROC_TROUBLESHOOT }
    300 { &$OpenWiki; Write-Menu_Troubleshooting }
    500 { &$OpenLogs; Write-Menu_Troubleshooting }
    1 {
      Stop-QuickBooksProcesses
      Repair-LevelOne_GenuineClientModule
      Write-Menu_Troubleshooting
      break
    }
    2 {
      Stop-QuickBooksProcesses
      Repair-LevelTwo_GenuineClientModule_SanityCheck
      Write-Menu_Troubleshooting
      break
    }
    3 {
      Repair-LevelThree_Reactivation
      Write-Host "Starting reactivation process..."
      Invoke-NextProcess $PROC_ACTIVATE
      break
    }
    4 { 
      Write-Error_UninstallUnsupported
      Write-Menu_Troubleshooting
      break
    }
    5 {
      Stop-QuickBooksProcesses
      Install-ClientModule
      Write-Menu_Troubleshooting
      break
    }
    6 { Write-Menu_LinkOptions; break }
    default { Write-Menu_Troubleshooting; break }
  }
}

function Write-Menu_LinkOptions {
  Write-HeaderLabel
  Write-Host "$(Format-Text "Select a link to jump to" -Foreground Gray -Formatting Bold, Underline)`n"
  Write-Host "1 - View the qbactivator Wiki"
  Write-Host "2 - Terminate QuickBooks processes"
  Write-Host "3 - View qbactivator logs"
  Write-Host "0 - Back"
  $query = Read-Host "`n#"
  Write-Host -NoNewLine "Selected: $query"; Write-Host -NoNewLine "`r                              `r" # To transcript # Debug
  switch ($query) {
    0 { Write-Menu_Troubleshooting; break }
    10 { &$InvokeGeneralActivation }
    100 { &$ExitQbactivator }
    200 { Invoke-NextProcess $PROC_TROUBLESHOOT }
    300 { &$OpenWiki; Write-Menu_LinkOptions }
    500 { &$OpenLogs; Write-Menu_LinkOptions }
    1 {
      Write-Host "Opening qbactivator Wiki..."
      &$OpenWiki
      Write-Menu_LinkOptions
      break
    }
    2 { 
      Stop-QuickBooksProcesses
      Write-Menu_LinkOptions
      break
    }
    3 {
      &$OpenLogs
      Write-Menu_LinkOptions
      break
    }
    default { Write-Menu_LinkOptions; break }
  }
}

function Write-LieScolding {
  # from `Write-LieResponse`
  param($Mssg, [Switch]$ReadAKey)

  Clear-Terminal
  Write-Host "$Mssg" -ForegroundColor White -BackgroundColor DarkRed
  Write-InfoLink -NoExit

  if ($ReadAKey) { Read-Host }
  else { Start-Sleep -Milliseconds $TIME_SLOW }

  Write-Menu_Main
}

function Write-LieResponse {
  # from `Write-Menu_Main`
  Write-HeaderLabel
  Write-Host "Do you really have one?`n"
  Write-Host "1. No, I lied."
  Write-Host "2. I have a cat."
  Write-Host "3. I can't remeber it."
  Write-Host "4. My dog ate my license."
  Write-Host "5. Yes, I do."
  Write-Host "6. I just wanted to see what would happen."
  $query = Read-Host "`n#"
    
  switch ($query) {
    0 { break }
    1 { Write-LieScolding "Lying is bad." }
    2 { Write-LieScolding "Having a cat does not make you a good person." }
    3 { Write-LieScolding "It's likely you never will." }
    4 { Write-LieScolding "Ha ha... nice try." }
    5 { Get-UserOwnLicense }
    6 { Write-LieScolding "And now you've wasted both our time." -ReadAKey }
    default { Write-LieResponse }
  }
}

function Write-Error_IsManualAdministrator {
  Clear-Terminal
  New-ToastNotification -ToastText "User started as Administrator." -ToastTitle "qbactivator Error"
  Write-Host "User started as Administrator" -ForegroundColor White -BackgroundColor DarkRed
  Write-Host "`nDo not manually (right-click) run qbactivator as`nadministrator. This will result in errors during`ninstallation. Please start the script normally." -ForegroundColor White
  Write-InfoLink -ReturnToMenu
  Pause
}

function Write-Error_CannotStartInstaller {
  Clear-Terminal
  New-ToastNotification -ToastText "Failed to start the installer." -ToastTitle "Installer Error"
  Write-Host "Unable to execute the installer" -ForegroundColor White -BackgroundColor DarkRed
  Write-Host "`nPlease ensure that you are using a genuine installer`ndownloaded from Intuit." -ForegroundColor White
  Write-InfoLink -ReturnToMenu
  Pause
}

function Write-Error_NoInternetConnectivity {
  Clear-Terminal
  New-ToastNotification -ToastText "No internet connectivity." -ToastTitle "Connection Error"
  Write-Host "Unable to start the download" -ForegroundColor White -BackgroundColor DarkRed
  Write-Host "`nThere is no internet connectivity at this time.`nPlease check the connection and try again." -ForegroundColor White
  Write-InfoLink -ReturnToMenu
  Pause
}

function Write-Error_QuickBooksIsInstalled {
  Clear-Terminal
  New-ToastNotification -ToastText "QuickBooks is already installed." -ToastTitle "Unable to Install"
  Write-Host "A version of QuickBooks is already installed" -ForegroundColor White -BackgroundColor DarkRed
  Write-Host "`nAll previous versions must be removed before installation." -ForegroundColor Yellow
  Write-Host "`nIf you are requesting activation-only, remove the installer`nfrom this location and restart the activator. The activator`nimmediately checks for a QuickBooks installation executable`nand runs it if one is available." -ForegroundColor White
  Write-InfoLink -ReturnToMenu
  Pause
}

function Write-Error_QuickBooksNotInstalled {
  Clear-Terminal
  New-ToastNotification -ToastText "QuickBooks is not installed." -ToastTitle "Unable to Activate"
  Write-Host "QuickBooks is not installed on the system" -ForegroundColor White -BackgroundColor DarkRed
  Write-Host "`nThe activation cannot be completed." -ForegroundColor Yellow
  Write-Host "`nPlease ensure that a QuickBooks product is correctly and`ncompletely installed before requesting activation." -ForegroundColor White
  Write-InfoLink -ReturnToMenu
  Pause
}

function Write-Error_FileNotFound($File) {
  Clear-Terminal
  New-ToastNotification -ToastText "File `"$File`" not found." -ToastTitle "Download Error"
  Write-Host "The requested file could not be downloaded" -ForegroundColor White -BackgroundColor DarkRed
  Write-Host "`nThe file was not found on the server at `"$File`"" -ForegroundColor White
  Write-Host "Please submit this issue to @neuralpain. Thank you." -ForegroundColor White
  Write-InfoLink -ReturnToMenu
  Pause
}

function Write-Error_UnableToVerifyInstaller {
  Clear-Terminal
  New-ToastNotification -ToastText "Unable to verify `"$Script:INSTALLER_OBJECT`"." -ToastTitle "Installer Error"
  Write-Host "Failed to verify the installer." -ForegroundColor White -BackgroundColor DarkRed
  Write-Host "`nThe installer `"$Script:INSTALLER_OBJECT`" may be corrupted." -ForegroundColor Yellow
  Write-InfoLink -ReturnToMenu
  Pause
}

function Write-Error_UninstallUnsupported {
  Write-Host "---"
  Write-Host "Uninstall currently unsupported." -ForegroundColor Yellow
  Start-Sleep -Milliseconds $TIME_NORMAL
}

function Invoke-NextProcess {
  param ([Parameter(Mandatory = $true)]$NextProcess)
  
  $Script:RUN_NEXT_PROCEDURE = $NextProcess
  
  switch ($NextProcess) {
    $PROC_DOWNLOAD {
      Select-QuickBooksVersion
      Get-QuickBooksObject
      if ($null -eq $Script:RUN_NEXT_PROCEDURE) { break }
      elseif ($Script:INSTALLER_DOWNLOAD_ONLY) {
        &$TestInternetAvailable
        Start-InstallerDownload
        break
      }
      else {
        &$TestInternetAvailable
        Start-InstallerDownload
        Invoke-NextProcess $PROC_LICENSE
      }
    }
    $PROC_LICENSE {
      &$LocateQuickBooksInstaller
      if ($Script:INSTALLER_AVAILABLE) { &$ValidateQuickBooksInstaller }
      else { Invoke-NextProcess $PROC_DOWNLOAD } # get an installer
      Get-IntuitLicense $Script:INSTALLER_HASH
      Install-IntuitLicense
      Invoke-NextProcess $PROC_INSTALL
      break
    }
    $PROC_INSTALL {
      if ($Script:INSTALLER_IS_VALID) {
        Invoke-QuickBooksInstaller
        &$VerifyIfQuickBooksIsInstalled
        if ($Script:QUICKBOOKS_INSTALL_ONLY) { break }
        else { Invoke-NextProcess $PROC_ACTIVATE }
      }
      else { break }
    }
    $PROC_ACTIVATE {
      Start-PosActivation
      if ($null -eq $Script:RUN_NEXT_PROCEDURE) { break }
      else { Invoke-NextProcess $PROC_NEXT_STAGE }
    }
    $PROC_TROUBLESHOOT { Write-Menu_Troubleshooting }
    $PROC_EXIT {
      Write-Action_ExitActivator
      exit $EXIT_QBA
    }
    $PROC_NEXT_STAGE { exit $OK }
    $PROC_RETURN_MAIN { Write-Menu_Main }
    default { Invoke-NextProcess $PROC_RETURN_MAIN }
  }

  Invoke-NextProcess $PROC_RETURN_MAIN
}

# -------- start PowerShell execution -------- #

Start-Transcript $LOG
Clear-Terminal

if ("C:\Windows\system32" -eq $pwd) {
  Write-Error_IsManualAdministrator
  exit $EXIT_QBA
}
else {
  &$VerifyIfQuickBooksIsInstalled
  Write-Menu_Main
}

# -------- end PowerShell execution -------- #

exit
